require "enemy"

function love.load()
	player = {}
	player.x = 465
	player.y = 510
	player.w = 30
	player.h = 30
	player.speed = 300
	player.bullets = {}
	
	devConsole = false
	
	score = 0
	
	paused = false
	
	drawGameOver = false
	
end

function love.update(dt)	
	if paused == false then
		bulletCollision()
		enemy.update(dt)

		if love.keyboard.isDown("left") then
			player.x = player.x - player.speed * dt
		end
		if love.keyboard.isDown("right") then
			player.x = player.x + player.speed * dt
		end
	
		if player.x >= 930 then
			player.x = 930
		end
		if player.x <= 0 then
			player.x = 0
		end
	
		for i,v in ipairs(player.bullets) do
			v.y = v.y - 1000 * dt
		
			if v.y <= -2 then
				table.remove(player.bullets, i)
			end
		end
	
		if groundContacts == 10 then
			gameOver()
		end
	end
end

function love.draw()
	enemy.draw()

	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle("fill", player.x, player.y, player.w, player.h)
	
	love.graphics.setColor(255, 255, 255)
	for i,v in ipairs(player.bullets) do
		love.graphics.rectangle("fill", v.x, v.y, 4, 4)
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("score: "..tostring(score), 10, 10)
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("enemies landed = "..tostring(groundContacts), 10, 25)
	
	if devConsole == true then
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("fps = "..tostring(love.timer.getFPS()), 10, 40)
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("timer = "..tostring(enemy.timer), 10, 85)
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("bullets in table = "..tostring(#player.bullets), 10, 55)
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("enemies in table = "..tostring(#enemy), 10, 70)
	end
	
	if drawGameOver == true then
		love.graphics.setColor(0, 0, 0)
		love.graphics.rectangle("fill", 0, 0, 960, 540)
		
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("GAME OVER", 475, 270)
	end
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end	
	
	if key == "space" then
		shoot()
	end
	
	if key == "k" and devConsole == false then
		devConsole = true
	end
	if key == "l" and devConsole == true then
		devConsole = false
	end
	
	if key == "o" and paused == false then
		paused = true
	end
	if key == "p" and paused == true then
		paused = false
	end
end

function shoot()
	if paused == false then
		bullet = {}
		bullet.x = player.x + 13
		bullet.y = player.y - 4
		table.insert(player.bullets, bullet)
	end
end

function bulletCollision()
	for i,v in ipairs(enemy) do
		for ia, va in ipairs(player.bullets) do
			if va.x + 4 > v.x and
			va.x < v.x + 30 and
			va.y + 4 > v.y and
			va.y < v.y + 30 then
				score = score + 1
				table.remove(enemy, i)
				table.remove(player.bullets, ia)
			end
		end
	end
end

function gameOver()
	paused = true
	drawGameOver = true
end

